/*     Utilidade para ver pantallas de Spectrum e convertilas de/a GIF     */
/*                 Programada por Alberto Garcia Gonzalez                  */
/*              Cabeceira para GCC 2.7.2.1 LiNUX / SVGAlib                 */

/* ULTIMA REVISION: 4-3-99 0:11 */

#include <vga.h>
#include <vgagl.h>
#include <sys/stat.h>
#include <ctype.h>
#include <unistd.h>
#include <time.h>

#define bpmemcpy memcpy
#define bpfread fread
#define bpfwrite fwrite

#define PLATAFORMA "LiNUX i386 SVGAlib"

/***************************************************************************/

void zxsee_init(void)    /* Quitamos privilexios se o programa e suid root */
{
 if (seteuid(getuid()))
    error(err_interno);
}

/***************************************************************************/

dword filelength(int descriptor)
{
 struct stat buffer;
 if (fstat (descriptor,&buffer))
    error (err_datos);
 return (dword)buffer.st_size;
}

/***************************************************************************/

char *strupr(char *cadena)
{
 char c,*tmp=cadena;
 while ((c=*tmp) != 0)
     *tmp++=toupper(c);
 return cadena;
}    

/***************************************************************************/

void modo13h(void)
{
 seteuid(0);                        /* Obtemo-los permisos de superusuario */
 vga_init();
 if (seteuid(getuid()))          /* E voltamos o nivel de usuario anterior */
    error(err_interno);
 vga_setmode(G320x200x256);
 gl_setcontextvga(G320x200x256);
 gl_disableclipping();
}

/***************************************************************************/

void modotexto(void)
{
 vga_setmode(TEXT);
}

/***************************************************************************/

void putcolor (byte color, byte r, byte g, byte b)
{
 gl_setpalettecolor((int)color,(int)r,(int)g,(int)b);
}

/***************************************************************************/

void vaciar(bytepunt buffer)
{
 memset(buffer,0,64000);
}

/***************************************************************************/

void volcar(bytepunt buffer)
{
 gl_putbox(0,0,320,200,buffer);
}

/***************************************************************************/

void espera_vret(void)
{
 vga_waitretrace();
}

/***************************************************************************/

int teclapulsada(void)
{
 return vga_getkey();
}

/***************************************************************************/

int leetecla(void)
{
 return vga_getch();
}

/***************************************************************************/

void mostrar_pantalla(bytepunt buf1,bytepunt buf2)
{
 struct timespec t;
 t.tv_sec = 0;
 t.tv_nsec = 500000000;
 while (1) {
       volcar(buf1);
       nanosleep(&t,NULL);
       if (teclapulsada()) return;
       volcar(buf2);
       nanosleep(&t,NULL);
       if (teclapulsada()) return;
 }
}

/***************************************************************************/
