/*     Utilidade para ver pantallas de Spectrum e convertilas de/a GIF     */
/*          Programada por Alberto Garcia Gonzalez - 24/03/98              */
/*           Funcions para tratar coas pantallas do Spectrum               */

/* ULTIMA REVISION: 3-3-99 23:30 */

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

dword scr_offset(int tipo);
void ver_pantalla(byte pant[6912],byte b_n,byte inv);
void a_320x200(bytepunt buffer,int tx,int ty);
bytepunt scr2buf(byte pant[6912],byte b_n,byte inv,byte fls);
bytepunt scr2gif(byte pant[6912],byte b_n,byte inv,dword *tamanho);
bytepunt scr2pcx(byte pant[6912],byte b_n,byte inv,dword *tamanho);
void buf2scr(bytepunt buffer,byte pant[6912]);
void a_2_colores(bytepunt buffer,byte pant[6912],int x,int y);
byte equiv_spectrum(byte color[3]);
dword distancia(byte a[3],byte b[3]);
void cargar_z80(char *nome,byte pantalla[]);
void cargar_tap(char *nome,byte pantalla[]);
void escribir_tap(byte pantalla[],FILE *fich,char *nome);
void leer_color_borde(FILE *fich,int tipo,char *nome);

byte color_borde = 0;                        /* Color do borde por defecto */

/***************************************************************************/

void ver_pantalla(byte pant[6912],byte b_n,byte inv)
{
 bytepunt buf1;
 bytepunt buf2;
 int i;
 buf1 = scr2buf(pant,b_n,inv,0);
 buf2 = scr2buf(pant,b_n,inv,1);
 a_320x200(buf1,256,192);
 a_320x200(buf2,256,192);
 modo13h();
 for (i=0;i<17;i++) putcolor(i,colores[i][0],colores[i][1],colores[i][2]);
 mostrar_pantalla(buf1,buf2);
 free(buf1);
 free(buf2);
 while (teclapulsada()) leetecla();
 modotexto();
}

/***************************************************************************/

void a_320x200(bytepunt buffer,int tx,int ty)
{
 sdword x,y;
 dword sup,lat;
 sup = (dword)320*(200-(ty&254))/2;
 lat = (320-tx)/2;
 for (y=ty-1;y>=0;y--)
    for (x=tx-1;x>=0;x--)
       buffer[sup+lat+y*320+x]=buffer[x+y*tx];

 if (ty & 1) {
       for (x=320;x<sup;x++) buffer[x]=buffer[x+64000-sup] = color_borde;
       for (x=0;x<320;x++) buffer[x] = color_borde;
 } else {
       for (x=0;x<sup;x++) buffer[x]=buffer[x+64000-sup] = color_borde;
 }
 
 for (y=0;y<ty;y++)
    for (x=0;x<lat;x++)
       buffer[sup+320*y+x]=buffer[sup+320*(y+1)-lat+x] = color_borde;

 if (tx & 1) {
       for (y=1;y<=ty;y++) buffer[sup+320*y-lat-1] = color_borde;
 }
 
}

/***************************************************************************/

bytepunt scr2gif(byte pant[6912],byte b_n,byte inv,dword *tamanho)
{
 bytepunt buffer;
 bytepunt result;
 dword tam;
 buffer = scr2buf(pant,b_n,inv,0);
 result = comprimir_gif(buffer,&tam);
 *tamanho = tam;
 free(buffer);
 return result;
}

/***************************************************************************/

bytepunt scr2pcx(byte pant[6912],byte b_n,byte inv,dword *tamanho)
{
 bytepunt buffer;
 bytepunt result;
 dword tam;
 buffer = scr2buf(pant,b_n,inv,0);
 result = comprimir_pcx(buffer,&tam);
 *tamanho = tam;
 free(buffer);
 return result;
}

/***************************************************************************/

bytepunt scr2buf(byte pant[6912],byte b_n,byte inv,byte fls)
{
 bytepunt buf;
 byte valor,atrib,tinta,papel,brillo=8;
 int linea,fila,bloque,col,n;
 dword i;
 if ((buf = (bytepunt) malloc (64000)) == NULL)
       error (non_hai_mem);
 i=0;
 for (bloque=0;bloque<3;bloque++)
    for (fila=0;fila<8;fila++)
       for (linea=0;linea<8;linea++)
          for (col=0;col<32;col++) {
                valor=pant[bloque*2048+linea*256+fila*32+col];
                atrib=pant[6144+bloque*256+fila*32+col];
                tinta=atrib & 7;
                if (b_n) tinta=7;
                papel=(atrib >> 3) & 7;
                if (b_n) papel=0;
                if (inv) {
                      tinta = tinta + papel;
                      papel = tinta - papel;
                      tinta = tinta - papel;
                }
                if (!b_n) brillo=(atrib >> 3) & 8;
                if ((atrib & 128) && fls) {
                      tinta = tinta + papel;
                      papel = tinta - papel;
                      tinta = tinta - papel;
                }
                for (n=7;n>=0;n--) {
                      buf[i++]=(1&(valor>>n))*tinta+
                               (1-(1&(valor>>n)))*papel+brillo;
                }
          }
 return buf;
}

/***************************************************************************/

void buf2scr(bytepunt buffer,byte pant[6912])
{
 int x,y;
 int linea,fila,bloque,col,i,n;
 byte valor;

 for (y=0;y<24;y++)
    for (x=0;x<32;x++)
       a_2_colores(buffer,pant,x,y);

 i=0;                                           /* O principio da pantalla */
 for (bloque=0;bloque<3;bloque++)
    for (fila=0;fila<8;fila++)
       for (linea=0;linea<8;linea++)
          for (col=0;col<32;col++) {
                valor = 0;
                for (n=7;n>=0;n--) {
                      valor |= buffer[i++]<<n;
                }
                pant[bloque*2048+linea*256+fila*32+col]=valor;
          }

}

/***************************************************************************/

void a_2_colores(bytepunt buffer,byte pant[6912],int x,int y)
{
 byte tinta[3];
 byte papel[3];
 byte *color,*ganador,col,ncol;
 int dx,dy;
 dword tmp;
 byte val_tinta=0,val_papel=15;

 /* Convertimos cada cor ao mais parecido da paleta do Spectrum */

 for (dy=0;dy<8;dy++)
    for (dx=0;dx<8;dx++) {
       tmp = 256*(8*y + dy) + 8*x + dx;
       color = paleta+3*buffer[tmp];
       col = buffer[tmp] = equiv_spectrum(color);
       if ((col&7)>=(val_tinta&7)) val_tinta=col;
       if ((col&7)<=(val_papel&7)) val_papel=col;
    }

 /* Inicializamos tinta e papel as cores mais distintas que tenhamos */

 for (col=0;col<3;col++) {
       tinta[col]=colores[val_tinta][col];
       papel[col]=colores[val_papel][col];
 }

 /* Buscamo-las cores medias da tinta e do papel */

 val_tinta = val_papel = 0;
 for (dy=0;dy<8;dy++)
    for (dx=0;dx<8;dx++) {
       ncol=buffer[256*(8*y + dy) + 8*x + dx];
       color = colores[ncol];
       if (distancia(tinta,color)<distancia(papel,color)) {
             ganador = tinta;
             col = val_tinta++; /* As veces que ganhou a tinta */
       }
       else {
             ganador = papel;
             col = val_papel++; /* As veces que ganhou o papel */
       }
       ganador[0]=((dword)ganador[0]*col+color[0]) / (col+1);
       ganador[1]=((dword)ganador[1]*col+color[1]) / (col+1);
       ganador[2]=((dword)ganador[2]*col+color[2]) / (col+1);
    }

 /* Agora aproximamos estas cores as do Spectrum */

 val_tinta = equiv_spectrum(tinta);
 val_papel = equiv_spectrum(papel);

 for (dy=0;dy<8;dy++)
    for (dx=0;dx<8;dx++) {
       tmp = 256*( 8*y + dy ) + 8*x + dx;
       col=buffer[tmp]&7;
       buffer[tmp] = (abs(col-(val_tinta&7)) < abs(col-(val_papel&7))) ?1:0;
    }

 /* Si un dos dous e o negro, ponhemoslle o mismo brillo que o outro */

 if ((val_tinta & 7) == 0) {
       val_tinta = val_papel & 8;
 }
 else if ((val_papel & 7) == 0) {
       val_papel = val_tinta & 8;
 }

 /* Actualizamo-la zona de atributos na pantalla do Spectrum */

 pant[6144 + 32*y + x]=(val_tinta&7)|((val_papel&7)<<3)|((val_papel&8)<<3);
}

/***************************************************************************/

byte equiv_spectrum(byte color[3])
{
 byte equiv=0,i;
 dword dist=20000,tmp;
 for (i=0;i<16;i++) {
       if ((tmp = distancia(color,colores[i]))<dist) {
             dist = tmp;
             equiv = i;
       }
 }
 return equiv;
}

/***************************************************************************/

dword distancia(byte a[3],byte b[3])
{
 dword resultado=0;
 sdword valor;
 byte i;
 for (i=0;i<3;i++) {
       valor = (sdword)a[i]-b[i];
       resultado += valor*valor;
 }
 return resultado;
}

/***************************************************************************/

dword scr_offset(int tipo)
{
 switch(tipo) {
    case EXT_SCR : return 0;
    case EXT_SP  : return 38;
    case EXT_SNA : return 27;
    case EXT_SIT : return 16412;
 }
 return 0;
}

/***************************************************************************/

void leer_color_borde(FILE *fich,int tipo,char *nome)
{
 switch(tipo) {
    case EXT_SCR : break;
    case EXT_SP  :
          if ((fseek(fich,34,SEEK_SET) == -1) ||
             (fread(&color_borde,1,1,fich) != 1)) {
                error1(err_lectura,nome);
          }
          break;
    case EXT_SNA :
          if ((fseek(fich,26,SEEK_SET) == -1) ||
             (fread(&color_borde,1,1,fich) != 1)) {
                error1(err_lectura,nome);
          }
          break;
    case EXT_SIT :
          if ((fseek(fich,27,SEEK_SET) == -1) ||
             (fread(&color_borde,1,1,fich) != 1)) {
                error1(err_lectura,nome);
          }
          break;
 }
}

/***************************************************************************/

void cargar_z80(char *nome,byte *pantalla)
{
 FILE *fich;
 byte buffer[10000];   /* Un tamanho mais ou menos arbitrario :) */
 dword l;
 byte ver30x=0;        /* Indica se a version e 3.0x */
 int i,j,k;
 int pos=0;
 if ((fich=fopen(nome,"rb")) == NULL) {
       error1(err_apertura,nome);
 }
 if (fread(buffer,100,1,fich) != 1) {
       error1(err_lectura,nome);
 }

 color_borde = (buffer[12] >> 1) & 7;
 
 if (buffer[30]==23 && !buffer[31]) {
       pos=55;                 /* Version 2.01 - Datos empezan en offs 55 */
 }
 else if (buffer[30]==54 && !buffer[31]) {
       ver30x=pos=86;          /* Version 3.0x - Datos empezan en offs 86 */
 }
 else buffer[12]=255;
 
 if (!pos && buffer[12]&192) {             /* Version anterior a 2.01 */
       pos=0;                              /* Non hai varios bloques */
       fseek(fich,30,SEEK_SET);
       if ((buffer[12]&32) == 0) {         /* Pantalla non comprimida */
             if (fread(pantalla,6912,1,fich) != 1) {
                   error1(err_lectura,nome);
             }
             else {
                   fclose(fich);
                   return;
             }
       }
 }
 else if ((buffer[pos]==255) && (buffer[pos+1]==255)) {
       fseek(fich,pos+3,SEEK_SET);
       if (fread(pantalla,6912,1,fich) != 1) {
             error1(err_lectura,nome);
       }
       else {
             fclose(fich);
             return;
       }
 }
 else fseek(fich,pos+3,SEEK_SET);
 
 if (pos) {                                      /* Se hai varios bloques */
       while (buffer[pos+2] != 8) {   /* Buscamos bloque 8 - mem de video */
             l=(dword)buffer[pos]+256*(dword)buffer[pos+1];  /* Lonxitude */
             if (l==65535 && ver30x) l=16384;     /* Especial da v3.05 */
             if (fseek(fich,l,SEEK_CUR)) {           /* Saltamolo */
                    error1(err_lectura,nome);
             }
             if (fread(buffer,3,1,fich)!=1) {    /* Cabeceira do seguinte */
                    error1(err_lectura,nome);
             }
             pos=0;
       }
       l=(dword)buffer[pos]+256*(dword)buffer[pos+1];
       if (l==65535 && ver30x) {               /* Bloque sen comprimir!! */
             if (fread(pantalla,6912,1,fich) != 1) {
                    error1(err_lectura,nome);
             }
             return;
       }
 }
 else l=6912;
 if (l>10000) l=10000;
 if (fread(buffer,l,1,fich) != 1) {
       error1(err_lectura,nome);
 }
 fclose(fich);
 i=j=0;
 do {
        while ((i<6912) && ((buffer[j] != 0xED) || (buffer[j+1] != 0xED))) {
              pantalla[i++]=buffer[j++];
        }
        for (k=0;i<6912 && k<buffer[j+2];k++) pantalla[i++]=buffer[j+3];
        j+=4;
 } while (i<6912);
}

/***************************************************************************/

void cargar_tap(char *nome,byte *pantalla)
{
 FILE *fich;
 dword tam;
 byte *tmp;
 int salir=0;
 if ((fich=fopen(nome,"rb")) == NULL) {
       error1(err_apertura,nome);
 }
 do {
       if (fread(&tam,2,1,fich) != 1) {    /* Lemos o tamanho do bloque */
             error1(tap_vacio,nome);
       }                  
       tmp = (byte *) &tam;
       tam = tmp[0] + 256 * tmp[1];
       if (tam == 6914) {       /* Se ten o tamanho dunha pantalla, lemolo */
             if ((fseek(fich,1,SEEK_CUR) == -1) ||
                (fread(pantalla,6912,1,fich) != 1)) {
                   error1(err_lectura,nome);
             }
             salir = 1;
       } else if (fseek(fich,tam,SEEK_CUR) == -1) {
             error1(err_lectura,nome);
       }
 } while(!salir);
 fclose(fich);
}

/***************************************************************************/

void escribir_tap(byte *pantalla,FILE *fich,char *nome)
{
 char cabec[]="\x13\0\0\x3SCREEN    \0\x1b\0\x40\0\x80\xd4\x2\x1b\xff";
 int i;
 byte checksum=255;
 for (i=0;i<=6911;i++) checksum ^= pantalla[i];
 if ((fwrite(cabec,24,1,fich) != 1) || (fwrite(pantalla,6912,1,fich) != 1) ||
     (fputc(checksum,fich) == EOF)) error1(err_crear,nome);
}

/***************************************************************************/

