/*     Utilidade para ver pantallas de Spectrum e convertilas de/a GIF     */
/*                Programada por Alberto Garcia Gonzalez                   */
/*                         Programa principal                              */

/* ULTIMA REVISION: 3-3-99 21:40 */

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

/* ELECCION DE IDIOMA */

#define GALEGO
//#define CASTELLANO
//#define ENGLISH

/**********************/

#include "mensaxes.h"

#define VERSION "2.2a"
#define B_NEGRO 1
#define INVERSO 2
#define EXT_SCR 32
#define EXT_TAP 33

#define EXT_SP  64
#define EXT_SNA 65
#define EXT_SIT 66
#define EXT_Z80 67
#define EXT_SLT 68

#define EXT_GIF 128
#define EXT_PCX 129

#define PANTALLA_SPECTRUM 32
#define SNAPSHOT 64
#define FORMATO_GRAFICO 128
#define TIPO_IMAXE(X) ((X) & 224)

typedef unsigned char byte;
void error(char *texto);
void error1(char *texto,char *param);
void leer(byte datos[],int num,FILE *fich);
byte paleta[768];

#ifdef __TURBOC__
   #include "turboc.h"
 #else
   typedef unsigned int dword;
   typedef int sdword;
   typedef byte * bytepunt;
#endif

#ifdef __GNUC__
   #ifdef __DJGPP__
      #include "djgpp.h"
   #else
      #include "linux.h"
   #endif
#endif

                                              byte colores[16][3]={
/*
Colores do Spectrum nunha paleta de 256 colores:

        NUMERO      COLOR                        Red  Green  Blue

          0         Negro                 */   {  0 ,   0 ,   0   },
 /*       1         Azul                  */   {  0 ,   0 ,   50  },
 /*       2         Vermello              */   {  50,   0 ,   0   },
 /*       3         Maxenta               */   {  50,   0 ,   50  },
 /*       4         Verde                 */   {  0 ,   50,   0   },
 /*       5         Cyan                  */   {  0 ,   50,   50  },
 /*       6         Amarelo               */   {  50,   50,   0   },
 /*       7         Branco                */   {  50,   50,   50  },
 /*       8         Negro brillante (?)   */   {  0 ,   0 ,   0   },
 /*       9         Azul brillante        */   {  0 ,   0 ,   63  },
 /*       10        Vermello brillante    */   {  63,   0 ,   0   },
 /*       11        Maxenta brillante     */   {  63,   0 ,   63  },
 /*       12        Verde brillante       */   {  0 ,   63,   0   },
 /*       13        Cyan brillante        */   {  0 ,   63,   63  },
 /*       14        Amarelo brillante     */   {  63,   63,   0   },
 /*       15        Branco brillante      */   {  63,   63,   63  }
                                                                 };

#include "gif.h"
#include "pcx.h"
#include "spectrum.h"

void parametros(void);
void pausa(void);
int tipo_parm(char *parm);

/***************************************************************************/

int main(int argc,char **argv)
{
 FILE *fich=NULL;
 int origen=0,destino=0; /* Posicion dos ficheiros orixe e destino en argv */
 int torigen=0,tdestino=0;           /* Tipo dos ficheiros orixe e destino */
 int b_n=0,inv=0;                         /* Branco e negro e modo inverso */
 int x,y;                       /* Tamanho das imaxes en coordenadas x e y */
 int i;
 dword tamanho;           /* Tamanho en bytes das imaxes a gardar no disco */
 bytepunt buffer=NULL;                          /* Onde gardamos as imaxes */
 byte pantalla[6912];      /* Onde gardamos a pantalla en formato Spectrum */
 zxsee_init();
 for (i=1;i<argc;i++) {
       switch (x=tipo_parm(argv[i])) {
             case EXT_Z80:
             case EXT_TAP:
             case EXT_SLT:
             case EXT_SIT:
             case EXT_SNA:
             case EXT_SP :
             case EXT_SCR:
             case EXT_PCX:
             case EXT_GIF: if (!origen) {
                                  torigen = x;
                                  origen = i;
                           }
                           else if (!destino) {
                                  tdestino = x;
                                  destino = i;
                           }
                           else parametros();
                           break;
             case B_NEGRO: if (!b_n) b_n=1; else parametros(); break;
             case INVERSO: if (!inv) inv=1; else parametros(); break;
             default     : parametros();
       }
 }
 if (!origen) parametros();   /* Se non hai ficheiro de orixe seleccionado */
 if ((TIPO_IMAXE(torigen) == TIPO_IMAXE(tdestino)) &&
    (TIPO_IMAXE(torigen) != PANTALLA_SPECTRUM)) {
      error (imxs_iguales);
 }
 if ((tdestino != EXT_SCR) && (tdestino != EXT_TAP) && 
    (TIPO_IMAXE(tdestino) != FORMATO_GRAFICO) && (tdestino)) {
      error (dest_invalido);                /* O destino so pode ser .scr, */
 }                                              /* .tap ou formato grafico */
 if ((destino) && ((fich=fopen(argv[destino],"rb")) != NULL)) {
       error1(fich_existe,argv[destino]);
 }
 if (TIPO_IMAXE(torigen) == FORMATO_GRAFICO) {
       switch(torigen) {
             case EXT_GIF: buffer = leer_gif(argv[origen],&x,&y); break;
             case EXT_PCX: buffer = leer_pcx(argv[origen],&x,&y); break;
       }
       if (((x != 256) || (y != 192)) && destino) {
             a_320x200(buffer,x,y);
             for (y=0;y<192;y++)            /* Ponhemos a imaxe en 256x192 */
                for (x=0;x<256;x++)
                   buffer[x+256*y]=buffer[1312+x+320*y];
       }
       if (b_n) {
             for (i=0;i<768;i+=3) {
                   paleta[i]=paleta[i+1]=paleta[i+2]=
                      (paleta[i]+paleta[i+1]+paleta[i+2])/3;
             }
       }
       if (inv) {
             for (i=0;i<768;i++) paleta[i]=63-paleta[i];
       }
       if (!destino) {
             modo13h(); 
             for (i=0;i<768;i+=3) {
                   putcolor(i/3,paleta[i],paleta[i+1],paleta[i+2]);
             }
             a_320x200(buffer,x,y);
             volcar(buffer);
             pausa();
             modotexto();
       }
 }
 if ((torigen == EXT_SCR) || (torigen == EXT_SP) || (torigen == EXT_SNA)
    || (torigen == EXT_SIT)) {
       if ((fich=fopen(argv[origen],"rb")) == NULL) {
             error1(err_apertura,argv[origen]);
       }
       if (fseek(fich,scr_offset(torigen),SEEK_SET) ||
          (fread(pantalla,6912,1,fich) != 1)) {
             error1(err_lectura,argv[origen]);
       }
       leer_color_borde(fich,torigen,argv[origen]);
       fclose(fich);
       if (!destino) ver_pantalla(pantalla,b_n,inv);
 }
 if ((torigen == EXT_Z80) || (torigen == EXT_SLT)) {
       cargar_z80(argv[origen],pantalla);
       if (!destino) ver_pantalla(pantalla,b_n,inv);
 }
 if (torigen == EXT_TAP) {
       cargar_tap(argv[origen],pantalla);
       if (!destino) ver_pantalla(pantalla,b_n,inv);
 }
 if ((destino) && ((fich=fopen(argv[destino],"wb")) == NULL)) {
       error1(err_crear,argv[destino]);
 }
 if (TIPO_IMAXE(tdestino) == FORMATO_GRAFICO) {
       switch(tdestino) {
             case EXT_GIF : buffer = scr2gif(pantalla,b_n,inv,&tamanho);
                            break;
             case EXT_PCX : buffer = scr2pcx(pantalla,b_n,inv,&tamanho);
                            break;
       }
       if (bpfwrite(buffer,1,tamanho,fich) != tamanho) {
             error1(err_crear,argv[destino]);
       }
       fclose(fich);
 }
 if (tdestino == EXT_SCR) {
       if (TIPO_IMAXE(torigen) == FORMATO_GRAFICO) {
             buf2scr(buffer,pantalla);
       }
       if (fwrite(pantalla,1,6912,fich) != 6912) {
             error1(err_crear,argv[destino]);
       }
       fclose(fich);
 }
 if (tdestino == EXT_TAP) {
       if (TIPO_IMAXE(torigen) == FORMATO_GRAFICO) {
             buf2scr(buffer,pantalla);
       }
       escribir_tap(pantalla,fich,argv[destino]);
       fclose(fich);
 }
 while (teclapulsada()) leetecla();
 return 0;
}

/***************************************************************************/

void parametros(void)
{
 error1(creditos,VERSION " " PLATAFORMA);
}

/***************************************************************************/

void pausa(void)
{
 while (teclapulsada()) leetecla();
 while (!teclapulsada());
}

/***************************************************************************/

int tipo_parm(char *parm)
{
 char *punt,tmp[255];
 if (strlen(parm)>=255)
    error(param_largo);
 strcpy(tmp,parm);
 strupr(tmp);
 if (!strcmp(tmp,"-B"))
       return B_NEGRO;
 if (!strcmp(tmp,"-I"))
       return INVERSO;
 punt=tmp+strlen(tmp)-1;
 while ((*punt != '.') && (punt != tmp)) punt--;
 if (!strcmp(punt,".GIF"))
       return EXT_GIF;
 if (!strcmp(punt,".PCX"))
       return EXT_PCX;
 if (!strcmp(punt,".SCR"))
       return EXT_SCR;
 if (!strcmp(punt,".SIT"))
       return EXT_SIT;
 if (!strcmp(punt,".SNA"))
       return EXT_SNA;
 if (!strcmp(punt,".SLT"))
       return EXT_SLT;
 if (!strcmp(punt,".SP"))
       return EXT_SP;
 if (!strcmp(punt,".Z80"))
       return EXT_Z80;
 if (!strcmp(punt,".TAP"))
       return EXT_TAP;
 return 0;
}

/***************************************************************************/

void error(char *texto)
{
 error1("%s",texto);
}

/***************************************************************************/

void error1(char *texto,char *param)
{
 fprintf(stderr,texto,param);
 fprintf(stderr,"\n");
 exit(1);
}

/***************************************************************************/

void leer(byte datos[],int num,FILE *fich)
{
 if (fread(datos,1,num,fich) != num)
       error(err_datos);
}

/***************************************************************************/

